Overview | Package | Class | Use | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## org.apache.poi.xssf.streaming
Class SXSSFSheet

    java.lang.Object
      org.apache.poi.xssf.streaming.SXSSFSheet

All Implemented Interfaces:
  java.lang.Cloneable, org.apache.poi.ss.usermodel.Sheet, poi.support.Iterable

    public class SXSSFSheet

extends java.lang.Object
implements org.apache.poi.ss.usermodel.Sheet, java.lang.Cloneable

Streaming version of XSSFSheet implementing the "BigGridDemo" strategy.

Author:
  Alex Geller, Four J's Development Tools

Field Summary

Fields inherited from interface org.apache.poi.ss.usermodel.Sheet
`BottomMargin, FooterMargin, HeaderMargin, LeftMargin, PANE_LOWER_LEFT, PANE_LOWER_RIGHT, PANE_UPPER_LEFT, PANE_UPPER_RIGHT, RightMargin, TopMargin`

Constructor Summary
`SXSSFSheet(SXSSFWorkbook workbook, XSSFSheet xSheet)`

Method Summary
`int` | `addMergedRegion(org.apache.poi.ss.util.CellRangeAddress region)` Adds a merged region of cells (hence those cells form one)
`void` | `addValidationData(org.apache.poi.ss.usermodel.DataValidation dataValidation)` Creates a data validation object
`void` | `autoSizeColumn(int column)` Adjusts the column width to fit the contents.
`void` | `autoSizeColumn(int column, boolean useMergedCells)` Adjusts the column width to fit the contents.
`void` | `changeRowNum(SXSSFRow row, int newRowNum)`
`org.apache.poi.ss.usermodel.Drawing` | `createDrawingPatriarch()` Creates the top-level drawing patriarch.
`void` | `createFreezePane(int colSplit, int rowSplit)` Creates a split (freezepane).
`void` | `createFreezePane(int colSplit, int rowSplit, int leftmostColumn, int topRow)` Creates a split (freezepane).
`org.apache.poi.ss.usermodel.Row` | `createRow(int rownum)` Create a new row within the sheet and return the high level representation
`void` | `createSplitPane(int xSplitPos, int ySplitPos, int leftmostColumn, int topRow, int activePane)` Creates a split pane.
`void` | `flushRows()` Flush all rows to disk.
`void` | `flushRows(int remaining)` Specifies how many rows can be accessed at most via getRow().
`boolean` | `getAutobreaks()` Flag indicating whether the sheet displays Automatic Page Breaks.
`org.apache.poi.ss.usermodel.Comment` | `getCellComment(int row, int column)` Returns cell comment for the specified row and column
`int[]` | `getColumnBreaks()` Retrieves all the vertical page breaks
`org.apache.poi.ss.usermodel.CellStyle` | `getColumnStyle(int column)` Returns the CellStyle that applies to the given (0 based) column, or null if no style has been set for that column
`int` | `getColumnWidth(int columnIndex)` get the width (in units of 1/256th of a character width )
`org.apache.poi.ss.usermodel.DataValidationHelper` | `getDataValidationHelper()`
`int` | `getDefaultColumnWidth()` Get the default column width for the sheet (if the columns do not define their own width) in characters
`short` | `getDefaultRowHeight()` Get the default row height for the sheet (if the rows do not define their own height) in twips (1/20 of a point)
`float` | `getDefaultRowHeightInPoints()` Get the default row height for the sheet (if the rows do not define their own height) in points.
`boolean` | `getDisplayGuts()` Get whether to display the guts or not, default value is true
`int` | `getFirstRowNum()` Gets the first row on the sheet
`boolean` | `getFitToPage()` Flag indicating whether the Fit to Page print option is enabled.
`org.apache.poi.ss.usermodel.Footer` | `getFooter()` Gets the user model for the default document footer.
`boolean` | `getForceFormulaRecalculation()` Whether Excel will be asked to recalculate all formulas when the workbook is opened.
`org.apache.poi.ss.usermodel.Header` | `getHeader()` Gets the user model for the default document header.
`boolean` | `getHorizontallyCenter()` Determine whether printed output for this sheet will be horizontally centered.
`int` | `getLastRowNum()` Gets the last row on the sheet
`short` | `getLeftCol()` The left col in the visible view when the sheet is first viewed after opening it in a viewer
`double` | `getMargin(short margin)` Gets the size of the margin in inches.
`org.apache.poi.ss.util.CellRangeAddress` | `getMergedRegion(int index)` Returns the merged region at the specified index
`int` | `getNumMergedRegions()` Returns the number of merged regions
`org.apache.poi.hssf.util.PaneInformation` | `getPaneInformation()` Returns the information regarding the currently configured pane (split or freeze)
`int` | `getPhysicalNumberOfRows()` Returns the number of physically defined rows (NOT the number of rows in the sheet)
`org.apache.poi.ss.usermodel.PrintSetup` | `getPrintSetup()` Gets the print setup object.
`boolean` | `getProtect()` Answer whether protection is enabled or disabled
`org.apache.poi.ss.usermodel.Row` | `getRow(int rownum)` Returns the logical row (not physical) 0-based.
`int[]` | `getRowBreaks()` Retrieves all the horizontal page breaks
`int` | `getRowNum(SXSSFRow row)`
`boolean` | `getRowSumsBelow()` Flag indicating whether summary rows appear below detail in an outline, when applying an outline.
`boolean` | `getRowSumsRight()` Flag indicating whether summary columns appear to the right of detail in an outline, when applying an outline.
`boolean` | `getScenarioProtect()` Answer whether scenario protection is enabled or disabled
`org.apache.poi.ss.usermodel.SheetConditionalFormatting` | `getSheetConditionalFormatting()`
`java.lang.String` | `getSheetName()` Returns the name of this sheet
`short` | `getTopRow()` The top row in the visible view when the sheet is first viewed after opening it in a viewer
`boolean` | `getVerticallyCenter()` Determine whether printed output for this sheet will be vertically centered.
`org.apache.poi.ss.usermodel.Workbook` | `getWorkbook()` Return the parent workbook
`java.io.InputStream` | `getWorksheetXMLInputStream()`
`void` | `groupColumn(int fromColumn, int toColumn)` Create an outline for the provided column range.
`void` | `groupRow(int fromRow, int toRow)` Tie a range of rows together so that they can be collapsed or expanded
`boolean` | `isColumnBroken(int column)` Determines if there is a page break at the indicated column
`boolean` | `isColumnHidden(int columnIndex)` Get the hidden state for a given column
`boolean` | `isDisplayFormulas()` Returns if formulas are displayed
`boolean` | `isDisplayGridlines()` Returns if gridlines are displayed
`boolean` | `isDisplayRowColHeadings()` Returns if RowColHeadings are displayed.
`boolean` | `isDisplayZeros()` Gets the flag indicating whether the window should show 0 (zero) in cells containing zero value.
`boolean` | `isPrintGridlines()` Gets the flag indicating whether this sheet displays the lines between rows and columns to make editing and reading easier.
`boolean` | `isRightToLeft()` Whether the text is displayed in right-to-left mode in the window
`boolean` | `isRowBroken(int row)` Determines if there is a page break at the indicated row
`boolean` | `isSelected()` Note - this is not the same as whether the sheet is focused (isActive)
`java.util.Iterator` | `iterator()`
`void` | `protectSheet(java.lang.String password)` Sets the protection enabled as well as the password
`org.apache.poi.ss.usermodel.CellRange` | `removeArrayFormula(org.apache.poi.ss.usermodel.Cell cell)` Remove a Array Formula from this sheet.
`void` | `removeColumnBreak(int column)` Removes a page break at the indicated column
`void` | `removeMergedRegion(int index)` Removes a merged region of cells (hence letting them free)
`void` | `removeRow(org.apache.poi.ss.usermodel.Row row)` Remove a row from this sheet.
`void` | `removeRowBreak(int row)` Removes the page break at the indicated row
`java.util.Iterator` | `rowIterator()` Returns an iterator of the physical rows
`org.apache.poi.ss.usermodel.CellRange` | `setArrayFormula(java.lang.String formula, org.apache.poi.ss.util.CellRangeAddress range)` Sets array formula to specified region for result.
`void` | `setAutobreaks(boolean value)` Flag indicating whether the sheet displays Automatic Page Breaks.
`org.apache.poi.ss.usermodel.AutoFilter` | `setAutoFilter(org.apache.poi.ss.util.CellRangeAddress range)` Enable filtering for a range of cells
`void` | `setColumnBreak(int column)` Sets a page break at the indicated column
`void` | `setColumnGroupCollapsed(int columnNumber, boolean collapsed)` Expands or collapses a column group.
`void` | `setColumnHidden(int columnIndex, boolean hidden)` Get the visibility state for a given column
`void` | `setColumnWidth(int columnIndex, int width)` Set the width (in units of 1/256th of a character width)
`void` | `setDefaultColumnStyle(int column, org.apache.poi.ss.usermodel.CellStyle style)` Sets the default column style for a given column.
`void` | `setDefaultColumnWidth(int width)` Set the default column width for the sheet (if the columns do not define their own width) in characters
`void` | `setDefaultRowHeight(short height)` Set the default row height for the sheet (if the rows do not define their own height) in twips (1/20 of a point)
`void` | `setDefaultRowHeightInPoints(float height)` Set the default row height for the sheet (if the rows do not define their own height) in points
`void` | `setDisplayFormulas(boolean show)` Sets whether the formulas are shown in a viewer
`void` | `setDisplayGridlines(boolean show)` Sets whether the gridlines are shown in a viewer
`void` | `setDisplayGuts(boolean value)` Set whether to display the guts or not
`void` | `setDisplayRowColHeadings(boolean show)` Sets whether the RowColHeadings are shown in a viewer
`void` | `setDisplayZeros(boolean value)` Set whether the window should show 0 (zero) in cells containing zero value.
`void` | `setFitToPage(boolean value)` Flag indicating whether the Fit to Page print option is enabled.
`void` | `setForceFormulaRecalculation(boolean value)` Control if Excel should be asked to recalculate all formulas when the workbook is opened, via the "sheetCalcPr fullCalcOnLoad" option.
`void` | `setHorizontallyCenter(boolean value)` Determines whether the output is horizontally centered on the page.
`void` | `setMargin(short margin, double size)` Sets the size of the margin in inches.
`void` | `setPrintGridlines(boolean show)` Sets the flag indicating whether this sheet should display the lines between rows and columns to make editing and reading easier.
`void` | `setRandomAccessWindowSize(int value)` Specifies how many rows can be accessed at most via getRow().
`void` | `setRightToLeft(boolean value)` Sets whether the worksheet is displayed from right to left instead of from left to right.
`void` | `setRowBreak(int row)` Sets a page break at the indicated row
`void` | `setRowGroupCollapsed(int row, boolean collapse)` Set view state of a groupped range of rows
`void` | `setRowSumsBelow(boolean value)` Flag indicating whether summary rows appear below detail in an outline, when applying an outline.
`void` | `setRowSumsRight(boolean value)` Flag indicating whether summary columns appear to the right of detail in an outline, when applying an outline.
`void` | `setSelected(boolean value)` Sets a flag indicating whether this sheet is selected.
`void` | `setVerticallyCenter(boolean value)` Determines whether the output is vertically centered on the page.
`void` | `setZoom(int numerator, int denominator)` Sets the zoom magnication for the sheet.
`void` | `shiftRows(int startRow, int endRow, int n)` Shifts rows between startRow and endRow n number of rows.
`void` | `shiftRows(int startRow, int endRow, int n, boolean copyRowHeight, boolean resetOriginalRowHeight)` Shifts rows between startRow and endRow n number of rows.
`void` | `showInPane(short toprow, short leftcol)` Sets desktop window pane display area, when the file is first opened in a viewer.
`void` | `ungroupColumn(int fromColumn, int toColumn)` Ungroup a range of columns that were previously groupped
`void` | `ungroupRow(int fromRow, int toRow)` Ungroup a range of rows that were previously groupped

Methods inherited from class java.lang.Object
`equals, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

Constructor Detail

### SXSSFSheet

    public SXSSFSheet(SXSSFWorkbook workbook,
                      XSSFSheet xSheet)
               throws java.io.IOException

Throws:
  `java.io.IOException`

Method Detail

### getWorksheetXMLInputStream

    public java.io.InputStream getWorksheetXMLInputStream()
                                                   throws java.io.IOException

  Throws:
    `java.io.IOException`

### iterator

    public java.util.Iterator iterator()

  Specified by:
    `iterator` in interface `poi.support.Iterable`

### createRow

    public org.apache.poi.ss.usermodel.Row createRow(int rownum)

  Create a new row within the sheet and return the high level representation

  Specified by:
    `createRow` in interface `org.apache.poi.ss.usermodel.Sheet`
  Parameters:
    `rownum` - row number
  Returns:
    high level Row object representing a row in the sheet
  See Also:
    `removeRow(Row)`

### removeRow

    public void removeRow(org.apache.poi.ss.usermodel.Row row)

  Remove a row from this sheet. All cells contained in the row are removed as well

  Specified by:
    `removeRow` in interface `org.apache.poi.ss.usermodel.Sheet`
  Parameters:
    `row` - representing a row to remove.

### getRow

    public org.apache.poi.ss.usermodel.Row getRow(int rownum)

  Returns the logical row (not physical) 0-based. If you ask for a row that is not defined you get a null. This is to say row 4 represents the fifth row on a sheet.

  Specified by:
    `getRow` in interface `org.apache.poi.ss.usermodel.Sheet`
  Parameters:
    `rownum` - row to get (0-based)
  Returns:
    Row representing the rownumber or null if its not defined on the sheet

### getPhysicalNumberOfRows

    public int getPhysicalNumberOfRows()

  Returns the number of physically defined rows (NOT the number of rows in the sheet)

  Specified by:
    `getPhysicalNumberOfRows` in interface `org.apache.poi.ss.usermodel.Sheet`
  Returns:
    the number of physically defined rows in this sheet

### getFirstRowNum

    public int getFirstRowNum()

  Gets the first row on the sheet

  Specified by:
    `getFirstRowNum` in interface `org.apache.poi.ss.usermodel.Sheet`
  Returns:
    the number of the first logical row on the sheet (0-based)

### getLastRowNum

    public int getLastRowNum()

  Gets the last row on the sheet

  Specified by:
    `getLastRowNum` in interface `org.apache.poi.ss.usermodel.Sheet`
  Returns:
    last row contained n this sheet (0-based)

### setColumnHidden

    public void setColumnHidden(int columnIndex,
                                boolean hidden)

  Get the visibility state for a given column

  Specified by:
    `setColumnHidden` in interface `org.apache.poi.ss.usermodel.Sheet`
  Parameters:
    `columnIndex` - - the column to get (0-based)
    `hidden` - - the visiblity state of the column

### isColumnHidden

    public boolean isColumnHidden(int columnIndex)

  Get the hidden state for a given column

  Specified by:
    `isColumnHidden` in interface `org.apache.poi.ss.usermodel.Sheet`
  Parameters:
    `columnIndex` - - the column to set (0-based)
  Returns:
    hidden - `false` if the column is visible

### setColumnWidth

    public void setColumnWidth(int columnIndex,
                               int width)

  Set the width (in units of 1/256th of a character width)

  The maximum column width for an individual cell is 255 characters. This value represents the number of characters that can be displayed in a cell that is formatted with the standard font.

  Specified by:
    `setColumnWidth` in interface `org.apache.poi.ss.usermodel.Sheet`
  Parameters:
    `columnIndex` - - the column to set (0-based)
    `width` - - the width in units of 1/256th of a character width

### getColumnWidth

    public int getColumnWidth(int columnIndex)

  get the width (in units of 1/256th of a character width )

  Specified by:
    `getColumnWidth` in interface `org.apache.poi.ss.usermodel.Sheet`
  Parameters:
    `columnIndex` - - the column to set (0-based)
  Returns:
    width - the width in units of 1/256th of a character width

### setDefaultColumnWidth

    public void setDefaultColumnWidth(int width)

  Set the default column width for the sheet (if the columns do not define their own width) in characters

  Specified by:
    `setDefaultColumnWidth` in interface `org.apache.poi.ss.usermodel.Sheet`
  Parameters:
    `width` - default column width measured in characters

### getDefaultColumnWidth

    public int getDefaultColumnWidth()

  Get the default column width for the sheet (if the columns do not define their own width) in characters

  Specified by:
    `getDefaultColumnWidth` in interface `org.apache.poi.ss.usermodel.Sheet`
  Returns:
    default column width measured in characters

### getDefaultRowHeight

    public short getDefaultRowHeight()

  Get the default row height for the sheet (if the rows do not define their own height) in twips (1/20 of a point)

  Specified by:
    `getDefaultRowHeight` in interface `org.apache.poi.ss.usermodel.Sheet`
  Returns:
    default row height measured in twips (1/20 of a point)

### getDefaultRowHeightInPoints

    public float getDefaultRowHeightInPoints()

  Get the default row height for the sheet (if the rows do not define their own height) in points.

  Specified by:
    `getDefaultRowHeightInPoints` in interface `org.apache.poi.ss.usermodel.Sheet`
  Returns:
    default row height in points

### setDefaultRowHeight

    public void setDefaultRowHeight(short height)

  Set the default row height for the sheet (if the rows do not define their own height) in twips (1/20 of a point)

  Specified by:
    `setDefaultRowHeight` in interface `org.apache.poi.ss.usermodel.Sheet`
  Parameters:
    `height` - default row height measured in twips (1/20 of a point)

### setDefaultRowHeightInPoints

    public void setDefaultRowHeightInPoints(float height)

  Set the default row height for the sheet (if the rows do not define their own height) in points

  Specified by:
    `setDefaultRowHeightInPoints` in interface `org.apache.poi.ss.usermodel.Sheet`
  Parameters:
    `height` - default row height

### getColumnStyle

    public org.apache.poi.ss.usermodel.CellStyle getColumnStyle(int column)

  Returns the CellStyle that applies to the given (0 based) column, or null if no style has been set for that column

  Specified by:
    `getColumnStyle` in interface `org.apache.poi.ss.usermodel.Sheet`

### addMergedRegion

    public int addMergedRegion(org.apache.poi.ss.util.CellRangeAddress region)

  Adds a merged region of cells (hence those cells form one)

  Specified by:
    `addMergedRegion` in interface `org.apache.poi.ss.usermodel.Sheet`
  Parameters:
    `region` - (rowfrom/colfrom-rowto/colto) to merge
  Returns:
    index of this region

### setVerticallyCenter

    public void setVerticallyCenter(boolean value)

  Determines whether the output is vertically centered on the page.

  Specified by:
    `setVerticallyCenter` in interface `org.apache.poi.ss.usermodel.Sheet`
  Parameters:
    `value` - true to vertically center, false otherwise.

### setHorizontallyCenter

    public void setHorizontallyCenter(boolean value)

  Determines whether the output is horizontally centered on the page.

  Specified by:
    `setHorizontallyCenter` in interface `org.apache.poi.ss.usermodel.Sheet`
  Parameters:
    `value` - true to horizontally center, false otherwise.

### getHorizontallyCenter

    public boolean getHorizontallyCenter()

  Determine whether printed output for this sheet will be horizontally centered.

  Specified by:
    `getHorizontallyCenter` in interface `org.apache.poi.ss.usermodel.Sheet`

### getVerticallyCenter

    public boolean getVerticallyCenter()

  Determine whether printed output for this sheet will be vertically centered.

  Specified by:
    `getVerticallyCenter` in interface `org.apache.poi.ss.usermodel.Sheet`

### removeMergedRegion

    public void removeMergedRegion(int index)

  Removes a merged region of cells (hence letting them free)

  Specified by:
    `removeMergedRegion` in interface `org.apache.poi.ss.usermodel.Sheet`
  Parameters:
    `index` - of the region to unmerge

### getNumMergedRegions

    public int getNumMergedRegions()

  Returns the number of merged regions

  Specified by:
    `getNumMergedRegions` in interface `org.apache.poi.ss.usermodel.Sheet`
  Returns:
    number of merged regions

### getMergedRegion

    public org.apache.poi.ss.util.CellRangeAddress getMergedRegion(int index)

  Returns the merged region at the specified index

  Specified by:
    `getMergedRegion` in interface `org.apache.poi.ss.usermodel.Sheet`
  Returns:
    the merged region at the specified index

### rowIterator

    public java.util.Iterator rowIterator()

  Returns an iterator of the physical rows

  Specified by:
    `rowIterator` in interface `org.apache.poi.ss.usermodel.Sheet`
  Returns:
    an iterator of the PHYSICAL rows. Meaning the 3rd element may not be the third row if say for instance the second row is undefined.

### setAutobreaks

    public void setAutobreaks(boolean value)

  Flag indicating whether the sheet displays Automatic Page Breaks.

  Specified by:
    `setAutobreaks` in interface `org.apache.poi.ss.usermodel.Sheet`
  Parameters:
    `value` - `true` if the sheet displays Automatic Page Breaks.

### setDisplayGuts

    public void setDisplayGuts(boolean value)

  Set whether to display the guts or not

  Specified by:
    `setDisplayGuts` in interface `org.apache.poi.ss.usermodel.Sheet`
  Parameters:
    `value` - - guts or no guts

### setDisplayZeros

    public void setDisplayZeros(boolean value)

  Set whether the window should show 0 (zero) in cells containing zero value. When false, cells with zero value appear blank instead of showing the number zero.

  Specified by:
    `setDisplayZeros` in interface `org.apache.poi.ss.usermodel.Sheet`
  Parameters:
    `value` - whether to display or hide all zero values on the worksheet

### isDisplayZeros

    public boolean isDisplayZeros()

  Gets the flag indicating whether the window should show 0 (zero) in cells containing zero value. When false, cells with zero value appear blank instead of showing the number zero.

  Specified by:
    `isDisplayZeros` in interface `org.apache.poi.ss.usermodel.Sheet`
  Returns:
    whether all zero values on the worksheet are displayed

### setRightToLeft

    public void setRightToLeft(boolean value)

  Sets whether the worksheet is displayed from right to left instead of from left to right.

  Specified by:
    `setRightToLeft` in interface `org.apache.poi.ss.usermodel.Sheet`
  Parameters:
    `value` - true for right to left, false otherwise.

### isRightToLeft

    public boolean isRightToLeft()

  Whether the text is displayed in right-to-left mode in the window

  Specified by:
    `isRightToLeft` in interface `org.apache.poi.ss.usermodel.Sheet`
  Returns:
    whether the text is displayed in right-to-left mode in the window

### setFitToPage

    public void setFitToPage(boolean value)

  Flag indicating whether the Fit to Page print option is enabled.

  Specified by:
    `setFitToPage` in interface `org.apache.poi.ss.usermodel.Sheet`
  Parameters:
    `value` - `true` if the Fit to Page print option is enabled.

### setRowSumsBelow

    public void setRowSumsBelow(boolean value)

  Flag indicating whether summary rows appear below detail in an outline, when applying an outline.

  When true a summary row is inserted below the detailed data being summarized and a new outline level is established on that row.

  When false a summary row is inserted above the detailed data being summarized and a new outline level is established on that row.

  Specified by:
    `setRowSumsBelow` in interface `org.apache.poi.ss.usermodel.Sheet`
  Parameters:
    `value` - `true` if row summaries appear below detail in the outline

### setRowSumsRight

    public void setRowSumsRight(boolean value)

  Flag indicating whether summary columns appear to the right of detail in an outline, when applying an outline.

  When true a summary column is inserted to the right of the detailed data being summarized and a new outline level is established on that column.

  When false a summary column is inserted to the left of the detailed data being summarized and a new outline level is established on that column.

  Specified by:
    `setRowSumsRight` in interface `org.apache.poi.ss.usermodel.Sheet`
  Parameters:
    `value` - `true` if col summaries appear right of the detail in the outline

### getAutobreaks

    public boolean getAutobreaks()

  Flag indicating whether the sheet displays Automatic Page Breaks.

  Specified by:
    `getAutobreaks` in interface `org.apache.poi.ss.usermodel.Sheet`
  Returns:
    `true` if the sheet displays Automatic Page Breaks.

### getDisplayGuts

    public boolean getDisplayGuts()

  Get whether to display the guts or not, default value is true

  Specified by:
    `getDisplayGuts` in interface `org.apache.poi.ss.usermodel.Sheet`
  Returns:
    boolean - guts or no guts

### getFitToPage

    public boolean getFitToPage()

  Flag indicating whether the Fit to Page print option is enabled.

  Specified by:
    `getFitToPage` in interface `org.apache.poi.ss.usermodel.Sheet`
  Returns:
    `true` if the Fit to Page print option is enabled.

### getRowSumsBelow

    public boolean getRowSumsBelow()

  Flag indicating whether summary rows appear below detail in an outline, when applying an outline.

  When true a summary row is inserted below the detailed data being summarized and a new outline level is established on that row.

  When false a summary row is inserted above the detailed data being summarized and a new outline level is established on that row.

  Specified by:
    `getRowSumsBelow` in interface `org.apache.poi.ss.usermodel.Sheet`
  Returns:
    `true` if row summaries appear below detail in the outline

### getRowSumsRight

    public boolean getRowSumsRight()

  Flag indicating whether summary columns appear to the right of detail in an outline, when applying an outline.

  When true a summary column is inserted to the right of the detailed data being summarized and a new outline level is established on that column.

  When false a summary column is inserted to the left of the detailed data being summarized and a new outline level is established on that column.

  Specified by:
    `getRowSumsRight` in interface `org.apache.poi.ss.usermodel.Sheet`
  Returns:
    `true` if col summaries appear right of the detail in the outline

### isPrintGridlines

    public boolean isPrintGridlines()

  Gets the flag indicating whether this sheet displays the lines between rows and columns to make editing and reading easier.

  Specified by:
    `isPrintGridlines` in interface `org.apache.poi.ss.usermodel.Sheet`
  Returns:
    `true` if this sheet displays gridlines.
  See Also:
    `to check if printing of gridlines is turned on or off`

### setPrintGridlines

    public void setPrintGridlines(boolean show)

  Sets the flag indicating whether this sheet should display the lines between rows and columns to make editing and reading easier. To turn printing of gridlines use `setPrintGridlines(boolean)`

  Specified by:
    `setPrintGridlines` in interface `org.apache.poi.ss.usermodel.Sheet`
  Parameters:
    `show` - `true` if this sheet should display gridlines.
  See Also:
    `setPrintGridlines(boolean)`

### getPrintSetup

    public org.apache.poi.ss.usermodel.PrintSetup getPrintSetup()

  Gets the print setup object.

  Specified by:
    `getPrintSetup` in interface `org.apache.poi.ss.usermodel.Sheet`
  Returns:
    The user model for the print setup object.

### getHeader

    public org.apache.poi.ss.usermodel.Header getHeader()

  Gets the user model for the default document header.

  Note that XSSF offers more kinds of document headers than HSSF does

  Specified by:
    `getHeader` in interface `org.apache.poi.ss.usermodel.Sheet`
  Returns:
    the document header. Never `null`

### getFooter

    public org.apache.poi.ss.usermodel.Footer getFooter()

  Gets the user model for the default document footer.

  Note that XSSF offers more kinds of document footers than HSSF does.

  Specified by:
    `getFooter` in interface `org.apache.poi.ss.usermodel.Sheet`
  Returns:
    the document footer. Never `null`

### setSelected

    public void setSelected(boolean value)

  Sets a flag indicating whether this sheet is selected.

  Note: multiple sheets can be selected, but only one sheet can be active at one time.

  Specified by:
    `setSelected` in interface `org.apache.poi.ss.usermodel.Sheet`
  Parameters:
    `value` - `true` if this sheet is selected
  See Also:
    `Workbook.setActiveSheet(int)`

### getMargin

    public double getMargin(short margin)

  Gets the size of the margin in inches.

  Specified by:
    `getMargin` in interface `org.apache.poi.ss.usermodel.Sheet`
  Parameters:
    `margin` - which margin to get
  Returns:
    the size of the margin

### setMargin

    public void setMargin(short margin,
                          double size)

  Sets the size of the margin in inches.

  Specified by:
    `setMargin` in interface `org.apache.poi.ss.usermodel.Sheet`
  Parameters:
    `margin` - which margin to get
    `size` - the size of the margin

### getProtect

    public boolean getProtect()

  Answer whether protection is enabled or disabled

  Specified by:
    `getProtect` in interface `org.apache.poi.ss.usermodel.Sheet`
  Returns:
    true => protection enabled; false => protection disabled

### protectSheet

    public void protectSheet(java.lang.String password)

  Sets the protection enabled as well as the password

  Specified by:
    `protectSheet` in interface `org.apache.poi.ss.usermodel.Sheet`
  Parameters:
    `password` - to set for protection. Pass `null` to remove protection

### getScenarioProtect

    public boolean getScenarioProtect()

  Answer whether scenario protection is enabled or disabled

  Specified by:
    `getScenarioProtect` in interface `org.apache.poi.ss.usermodel.Sheet`
  Returns:
    true => protection enabled; false => protection disabled

### setZoom

    public void setZoom(int numerator,
                        int denominator)

  Sets the zoom magnication for the sheet. The zoom is expressed as a fraction. For example to express a zoom of 75% use 3 for the numerator and 4 for the denominator.

  Specified by:
    `setZoom` in interface `org.apache.poi.ss.usermodel.Sheet`
  Parameters:
    `numerator` - The numerator for the zoom magnification.
    `denominator` - The denominator for the zoom magnification.

### getTopRow

    public short getTopRow()

  The top row in the visible view when the sheet is first viewed after opening it in a viewer

  Specified by:
    `getTopRow` in interface `org.apache.poi.ss.usermodel.Sheet`
  Returns:
    short indicating the rownum (0 based) of the top row

### getLeftCol

    public short getLeftCol()

  The left col in the visible view when the sheet is first viewed after opening it in a viewer

  Specified by:
    `getLeftCol` in interface `org.apache.poi.ss.usermodel.Sheet`
  Returns:
    short indicating the rownum (0 based) of the top row

### showInPane

    public void showInPane(short toprow,
                           short leftcol)

  Sets desktop window pane display area, when the file is first opened in a viewer.

  Specified by:
    `showInPane` in interface `org.apache.poi.ss.usermodel.Sheet`
  Parameters:
    `toprow` - the top row to show in desktop window pane
    `leftcol` - the left column to show in desktop window pane

### setForceFormulaRecalculation

    public void setForceFormulaRecalculation(boolean value)

  Control if Excel should be asked to recalculate all formulas when the workbook is opened, via the "sheetCalcPr fullCalcOnLoad" option. Calculating the formula values with `FormulaEvaluator` is the recommended solution, but this may be used for certain cases where evaluation in POI is not possible.

  Specified by:
    `setForceFormulaRecalculation` in interface `org.apache.poi.ss.usermodel.Sheet`

### getForceFormulaRecalculation

    public boolean getForceFormulaRecalculation()

  Whether Excel will be asked to recalculate all formulas when the workbook is opened.

  Specified by:
    `getForceFormulaRecalculation` in interface `org.apache.poi.ss.usermodel.Sheet`

### shiftRows

    public void shiftRows(int startRow,
                          int endRow,
                          int n)

  Shifts rows between startRow and endRow n number of rows. If you use a negative number, it will shift rows up. Code ensures that rows don't wrap around. Calls shiftRows(startRow, endRow, n, false, false);

  Additionally shifts merged regions that are completely defined in these rows (ie. merged 2 cells on a row to be shifted).

  Specified by:
    `shiftRows` in interface `org.apache.poi.ss.usermodel.Sheet`
  Parameters:
    `startRow` - the row to start shifting
    `endRow` - the row to end shifting
    `n` - the number of rows to shift

### shiftRows

    public void shiftRows(int startRow,
                          int endRow,
                          int n,
                          boolean copyRowHeight,
                          boolean resetOriginalRowHeight)

  Shifts rows between startRow and endRow n number of rows. If you use a negative number, it will shift rows up. Code ensures that rows don't wrap around

  Additionally shifts merged regions that are completely defined in these rows (ie. merged 2 cells on a row to be shifted).

  Specified by:
    `shiftRows` in interface `org.apache.poi.ss.usermodel.Sheet`
  Parameters:
    `startRow` - the row to start shifting
    `endRow` - the row to end shifting
    `n` - the number of rows to shift
    `copyRowHeight` - whether to copy the row height during the shift
    `resetOriginalRowHeight` - whether to set the original row's height to the default

### createFreezePane

    public void createFreezePane(int colSplit,
                                 int rowSplit,
                                 int leftmostColumn,
                                 int topRow)

  Creates a split (freezepane). Any existing freezepane or split pane is overwritten.

  Specified by:
    `createFreezePane` in interface `org.apache.poi.ss.usermodel.Sheet`
  Parameters:
    `colSplit` - Horizonatal position of split.
    `rowSplit` - Vertical position of split.
    `leftmostColumn` - Left column visible in right pane.
    `topRow` - Top row visible in bottom pane

### createFreezePane

    public void createFreezePane(int colSplit,
                                 int rowSplit)

  Creates a split (freezepane). Any existing freezepane or split pane is overwritten.

  Specified by:
    `createFreezePane` in interface `org.apache.poi.ss.usermodel.Sheet`
  Parameters:
    `colSplit` - Horizonatal position of split.
    `rowSplit` - Vertical position of split.

### createSplitPane

    public void createSplitPane(int xSplitPos,
                                int ySplitPos,
                                int leftmostColumn,
                                int topRow,
                                int activePane)

  Creates a split pane. Any existing freezepane or split pane is overwritten.

  Specified by:
    `createSplitPane` in interface `org.apache.poi.ss.usermodel.Sheet`
  Parameters:
    `xSplitPos` - Horizonatal position of split (in 1/20th of a point).
    `ySplitPos` - Vertical position of split (in 1/20th of a point).
    `topRow` - Top row visible in bottom pane
    `leftmostColumn` - Left column visible in right pane.
    `activePane` - Active pane. One of: PANE_LOWER_RIGHT, PANE_UPPER_RIGHT, PANE_LOWER_LEFT, PANE_UPPER_LEFT
  See Also:
    `Sheet.PANE_LOWER_LEFT`, `Sheet.PANE_LOWER_RIGHT`, `Sheet.PANE_UPPER_LEFT`, `Sheet.PANE_UPPER_RIGHT`

### getPaneInformation

    public org.apache.poi.hssf.util.PaneInformation getPaneInformation()

  Returns the information regarding the currently configured pane (split or freeze)

  Specified by:
    `getPaneInformation` in interface `org.apache.poi.ss.usermodel.Sheet`
  Returns:
    null if no pane configured, or the pane information.

### setDisplayGridlines

    public void setDisplayGridlines(boolean show)

  Sets whether the gridlines are shown in a viewer

  Specified by:
    `setDisplayGridlines` in interface `org.apache.poi.ss.usermodel.Sheet`
  Parameters:
    `show` - whether to show gridlines or not

### isDisplayGridlines

    public boolean isDisplayGridlines()

  Returns if gridlines are displayed

  Specified by:
    `isDisplayGridlines` in interface `org.apache.poi.ss.usermodel.Sheet`
  Returns:
    whether gridlines are displayed

### setDisplayFormulas

    public void setDisplayFormulas(boolean show)

  Sets whether the formulas are shown in a viewer

  Specified by:
    `setDisplayFormulas` in interface `org.apache.poi.ss.usermodel.Sheet`
  Parameters:
    `show` - whether to show formulas or not

### isDisplayFormulas

    public boolean isDisplayFormulas()

  Returns if formulas are displayed

  Specified by:
    `isDisplayFormulas` in interface `org.apache.poi.ss.usermodel.Sheet`
  Returns:
    whether formulas are displayed

### setDisplayRowColHeadings

    public void setDisplayRowColHeadings(boolean show)

  Sets whether the RowColHeadings are shown in a viewer

  Specified by:
    `setDisplayRowColHeadings` in interface `org.apache.poi.ss.usermodel.Sheet`
  Parameters:
    `show` - whether to show RowColHeadings or not

### isDisplayRowColHeadings

    public boolean isDisplayRowColHeadings()

  Returns if RowColHeadings are displayed.

  Specified by:
    `isDisplayRowColHeadings` in interface `org.apache.poi.ss.usermodel.Sheet`
  Returns:
    whether RowColHeadings are displayed

### setRowBreak

    public void setRowBreak(int row)

  Sets a page break at the indicated row

  Specified by:
    `setRowBreak` in interface `org.apache.poi.ss.usermodel.Sheet`
  Parameters:
    `row` - FIXME: Document this!

### isRowBroken

    public boolean isRowBroken(int row)

  Determines if there is a page break at the indicated row

  Specified by:
    `isRowBroken` in interface `org.apache.poi.ss.usermodel.Sheet`
  Parameters:
    `row` - FIXME: Document this!
  Returns:
    FIXME: Document this!

### removeRowBreak

    public void removeRowBreak(int row)

  Removes the page break at the indicated row

  Specified by:
    `removeRowBreak` in interface `org.apache.poi.ss.usermodel.Sheet`
  Parameters:
    `row` -

### getRowBreaks

    public int[] getRowBreaks()

  Retrieves all the horizontal page breaks

  Specified by:
    `getRowBreaks` in interface `org.apache.poi.ss.usermodel.Sheet`
  Returns:
    all the horizontal page breaks, or null if there are no row page breaks

### getColumnBreaks

    public int[] getColumnBreaks()

  Retrieves all the vertical page breaks

  Specified by:
    `getColumnBreaks` in interface `org.apache.poi.ss.usermodel.Sheet`
  Returns:
    all the vertical page breaks, or null if there are no column page breaks

### setColumnBreak

    public void setColumnBreak(int column)

  Sets a page break at the indicated column

  Specified by:
    `setColumnBreak` in interface `org.apache.poi.ss.usermodel.Sheet`
  Parameters:
    `column` -

### isColumnBroken

    public boolean isColumnBroken(int column)

  Determines if there is a page break at the indicated column

  Specified by:
    `isColumnBroken` in interface `org.apache.poi.ss.usermodel.Sheet`
  Parameters:
    `column` - FIXME: Document this!
  Returns:
    FIXME: Document this!

### removeColumnBreak

    public void removeColumnBreak(int column)

  Removes a page break at the indicated column

  Specified by:
    `removeColumnBreak` in interface `org.apache.poi.ss.usermodel.Sheet`
  Parameters:
    `column` -

### setColumnGroupCollapsed

    public void setColumnGroupCollapsed(int columnNumber,
                                        boolean collapsed)

  Expands or collapses a column group.

  Specified by:
    `setColumnGroupCollapsed` in interface `org.apache.poi.ss.usermodel.Sheet`
  Parameters:
    `columnNumber` - One of the columns in the group.
    `collapsed` - true = collapse group, false = expand group.

### groupColumn

    public void groupColumn(int fromColumn,
                            int toColumn)

  Create an outline for the provided column range.

  Specified by:
    `groupColumn` in interface `org.apache.poi.ss.usermodel.Sheet`
  Parameters:
    `fromColumn` - beginning of the column range.
    `toColumn` - end of the column range.

### ungroupColumn

    public void ungroupColumn(int fromColumn,
                              int toColumn)

  Ungroup a range of columns that were previously groupped

  Specified by:
    `ungroupColumn` in interface `org.apache.poi.ss.usermodel.Sheet`
  Parameters:
    `fromColumn` - start column (0-based)
    `toColumn` - end column (0-based)

### groupRow

    public void groupRow(int fromRow,
                         int toRow)

  Tie a range of rows together so that they can be collapsed or expanded

  Please note the rows being grouped must be in the current window, if the rows are already flushed then groupRow has no effect.

  Correct code:

             Workbook wb = new SXSSFWorkbook(100);  // keep 100 rows in memory
             Sheet sh = wb.createSheet();
             for (int rownum = 0; rownum < 1000; rownum++) {
                 Row row = sh.createRow(rownum);
                 if(rownum == 200)  {
                     sh.groupRow(100, 200);
                 }
             }

  Incorrect code:

             Workbook wb = new SXSSFWorkbook(100);  // keep 100 rows in memory
             Sheet sh = wb.createSheet();
             for (int rownum = 0; rownum < 1000; rownum++) {
                 Row row = sh.createRow(rownum);
             }
             sh.groupRow(100, 200); // the rows in the range [100, 200] are already flushed and groupRows has no effect

  Specified by:
    `groupRow` in interface `org.apache.poi.ss.usermodel.Sheet`
  Parameters:
    `fromRow` - start row (0-based)
    `toRow` - end row (0-based)

### ungroupRow

    public void ungroupRow(int fromRow,
                           int toRow)

  Ungroup a range of rows that were previously groupped

  Specified by:
    `ungroupRow` in interface `org.apache.poi.ss.usermodel.Sheet`
  Parameters:
    `fromRow` - start row (0-based)
    `toRow` - end row (0-based)

### setRowGroupCollapsed

    public void setRowGroupCollapsed(int row,
                                     boolean collapse)

  Set view state of a groupped range of rows

  Specified by:
    `setRowGroupCollapsed` in interface `org.apache.poi.ss.usermodel.Sheet`
  Parameters:
    `row` - start row of a groupped range of rows (0-based)
    `collapse` - whether to expand/collapse the detail rows

### setDefaultColumnStyle

    public void setDefaultColumnStyle(int column,
                                      org.apache.poi.ss.usermodel.CellStyle style)

  Sets the default column style for a given column. POI will only apply this style to new cells added to the sheet.

  Specified by:
    `setDefaultColumnStyle` in interface `org.apache.poi.ss.usermodel.Sheet`
  Parameters:
    `column` - the column index
    `style` - the style to set

### autoSizeColumn

    public void autoSizeColumn(int column)

  Adjusts the column width to fit the contents.

  This process can be relatively slow on large sheets, so this should normally only be called once per column, at the end of your processing.

  You can specify whether the content of merged cells should be considered or ignored. Default is to ignore merged cells.

  Specified by:
    `autoSizeColumn` in interface `org.apache.poi.ss.usermodel.Sheet`
  Parameters:
    `column` - the column index

### autoSizeColumn

    public void autoSizeColumn(int column,
                               boolean useMergedCells)

  Adjusts the column width to fit the contents.

  This process can be relatively slow on large sheets, so this should normally only be called once per column, at the end of your processing.

  You can specify whether the content of merged cells should be considered or ignored. Default is to ignore merged cells.

  Specified by:
    `autoSizeColumn` in interface `org.apache.poi.ss.usermodel.Sheet`
  Parameters:
    `column` - the column index
    `useMergedCells` - whether to use the contents of merged cells when calculating the width of the column

### getCellComment

    public org.apache.poi.ss.usermodel.Comment getCellComment(int row,
                                                              int column)

  Returns cell comment for the specified row and column

  Specified by:
    `getCellComment` in interface `org.apache.poi.ss.usermodel.Sheet`
  Returns:
    cell comment or `null` if not found

### createDrawingPatriarch

    public org.apache.poi.ss.usermodel.Drawing createDrawingPatriarch()

  Creates the top-level drawing patriarch.

  Specified by:
    `createDrawingPatriarch` in interface `org.apache.poi.ss.usermodel.Sheet`
  Returns:
    The new drawing patriarch.

### getWorkbook

    public org.apache.poi.ss.usermodel.Workbook getWorkbook()

  Return the parent workbook

  Specified by:
    `getWorkbook` in interface `org.apache.poi.ss.usermodel.Sheet`
  Returns:
    the parent workbook

### getSheetName

    public java.lang.String getSheetName()

  Returns the name of this sheet

  Specified by:
    `getSheetName` in interface `org.apache.poi.ss.usermodel.Sheet`
  Returns:
    the name of this sheet

### isSelected

    public boolean isSelected()

  Note - this is not the same as whether the sheet is focused (isActive)

  Specified by:
    `isSelected` in interface `org.apache.poi.ss.usermodel.Sheet`
  Returns:
    `true` if this sheet is currently selected

### setArrayFormula

    public org.apache.poi.ss.usermodel.CellRange setArrayFormula(java.lang.String formula,
                                                                 org.apache.poi.ss.util.CellRangeAddress range)

  Sets array formula to specified region for result.

  Specified by:
    `setArrayFormula` in interface `org.apache.poi.ss.usermodel.Sheet`
  Parameters:
    `formula` - text representation of the formula
    `range` - Region of array formula for result.
  Returns:
    the `CellRange` of cells affected by this change

### removeArrayFormula

    public org.apache.poi.ss.usermodel.CellRange removeArrayFormula(org.apache.poi.ss.usermodel.Cell cell)

  Remove a Array Formula from this sheet. All cells contained in the Array Formula range are removed as well

  Specified by:
    `removeArrayFormula` in interface `org.apache.poi.ss.usermodel.Sheet`
  Parameters:
    `cell` - any cell within Array Formula range
  Returns:
    the `CellRange` of cells affected by this change

### getDataValidationHelper

    public org.apache.poi.ss.usermodel.DataValidationHelper getDataValidationHelper()

  Specified by:
    `getDataValidationHelper` in interface `org.apache.poi.ss.usermodel.Sheet`

### addValidationData

    public void addValidationData(org.apache.poi.ss.usermodel.DataValidation dataValidation)

  Creates a data validation object

  Specified by:
    `addValidationData` in interface `org.apache.poi.ss.usermodel.Sheet`
  Parameters:
    `dataValidation` - The Data validation object settings

### setAutoFilter

    public org.apache.poi.ss.usermodel.AutoFilter setAutoFilter(org.apache.poi.ss.util.CellRangeAddress range)

  Enable filtering for a range of cells

  Specified by:
    `setAutoFilter` in interface `org.apache.poi.ss.usermodel.Sheet`
  Parameters:
    `range` - the range of cells to filter

### getSheetConditionalFormatting

    public org.apache.poi.ss.usermodel.SheetConditionalFormatting getSheetConditionalFormatting()

  Specified by:
    `getSheetConditionalFormatting` in interface `org.apache.poi.ss.usermodel.Sheet`

### setRandomAccessWindowSize

    public void setRandomAccessWindowSize(int value)

  Specifies how many rows can be accessed at most via getRow(). When a new node is created via createRow() and the total number of unflushed records would exeed the specified value, then the row with the lowest index value is flushed and cannot be accessed via getRow() anymore. A value of -1 indicates unlimited access. In this case all records that have not been flushed by a call to flush() are available for random access. A value of 0 is not allowed because it would flush any newly created row without having a chance to specify any cells.

### flushRows

    public void flushRows(int remaining)
                   throws java.io.IOException

  Specifies how many rows can be accessed at most via getRow(). The exeeding rows (if any) are flushed to the disk while rows with lower index values are flushed first.

  Throws:
    `java.io.IOException`

### flushRows

    public void flushRows()
                   throws java.io.IOException

  Flush all rows to disk. After this call no rows can be accessed via getRow()

  Throws:
    `java.io.IOException`

### changeRowNum

    public void changeRowNum(SXSSFRow row,
                             int newRowNum)

### getRowNum

    public int getRowNum(SXSSFRow row)

Overview | Package | Class | Use | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD